//## begin module%1.4%.codegen_version preserve=yes
//   Read the documentation to learn more about C++ code generator
//   versioning.
//## end module%1.4%.codegen_version

//## begin module%3F4FA77E01A8.cm preserve=no
//	  %X% %Q% %Z% %W%
//## end module%3F4FA77E01A8.cm

//## begin module%3F4FA77E01A8.cp preserve=no
//## end module%3F4FA77E01A8.cp

//## Module: LineList%3F4FA77E01A8; Package body
//## Subsystem: XSModel::Model::EmissionLines%3F4FA70400FF
//## Source file: /local/data/xerxes1/gordon/headas/Xspec/src/XSModel/Model/EmissionLines/LineList.cxx

//## begin module%3F4FA77E01A8.additionalIncludes preserve=no
//## end module%3F4FA77E01A8.additionalIncludes

//## begin module%3F4FA77E01A8.includes preserve=yes
#include "XSstreams.h"
//## end module%3F4FA77E01A8.includes

// LineList
#include <XSModel/Model/EmissionLines/LineList.h>
//## begin module%3F4FA77E01A8.declarations preserve=no
//## end module%3F4FA77E01A8.declarations

//## begin module%3F4FA77E01A8.additionalDeclarations preserve=yes
//## end module%3F4FA77E01A8.additionalDeclarations


// Class LineList::CannotOpen 

LineList::CannotOpen::CannotOpen (const string& msg)
  //## begin LineList::CannotOpen::CannotOpen%3F54FC41016E.hasinit preserve=yes
  : YellowAlert(" cannot open line list file named: ")
  //## end LineList::CannotOpen::CannotOpen%3F54FC41016E.hasinit
  //## begin LineList::CannotOpen::CannotOpen%3F54FC41016E.initialization preserve=yes
  //## end LineList::CannotOpen::CannotOpen%3F54FC41016E.initialization
{
  //## begin LineList::CannotOpen::CannotOpen%3F54FC41016E.body preserve=yes
  tcerr << msg << std::endl;
  //## end LineList::CannotOpen::CannotOpen%3F54FC41016E.body
}


// Class LineList::FileFormatError 

LineList::FileFormatError::FileFormatError (const string& msg)
  //## begin LineList::FileFormatError::FileFormatError%3F54FE120278.hasinit preserve=yes
  : YellowAlert("")
  //## end LineList::FileFormatError::FileFormatError%3F54FE120278.hasinit
  //## begin LineList::FileFormatError::FileFormatError%3F54FE120278.initialization preserve=yes
  //## end LineList::FileFormatError::FileFormatError%3F54FE120278.initialization
{
  //## begin LineList::FileFormatError::FileFormatError%3F54FE120278.body preserve=yes
  tcerr << msg << std::endl;
  //## end LineList::FileFormatError::FileFormatError%3F54FE120278.body
}


// Class LineList 


//## begin LineList::lineLists%3F4FB7F1032D.role preserve=no  public: static LineList { -> 1..nRHgN}
std::map<std::string, LineList*> LineList::s_lineLists;
//## end LineList::lineLists%3F4FB7F1032D.role

LineList::LineList()
  //## begin LineList::LineList%3F4FAE3B0150_const.hasinit preserve=yes
  : m_fileName(""),
    m_energyRange(std::pair<Real,Real>(.0,.0)),
    m_plasmaTemperature(.0),
    m_minEmissivity(.0),
    m_file(0),
    m_isWave(false)
  //## end LineList::LineList%3F4FAE3B0150_const.hasinit
  //## begin LineList::LineList%3F4FAE3B0150_const.initialization preserve=yes
  //## end LineList::LineList%3F4FAE3B0150_const.initialization
{
  //## begin LineList::LineList%3F4FAE3B0150_const.body preserve=yes
  //## end LineList::LineList%3F4FAE3B0150_const.body
}

LineList::LineList(const LineList &right)
  //## begin LineList::LineList%3F4FAE3B0150_copy.hasinit preserve=yes
  : m_fileName(right.m_fileName),
    m_energyRange(right.m_energyRange),
    m_plasmaTemperature(right.m_plasmaTemperature),
    m_minEmissivity(right.m_minEmissivity),
    m_file(0),
    m_isWave(right.m_isWave)
  //## end LineList::LineList%3F4FAE3B0150_copy.hasinit
  //## begin LineList::LineList%3F4FAE3B0150_copy.initialization preserve=yes
  //## end LineList::LineList%3F4FAE3B0150_copy.initialization
{
  //## begin LineList::LineList%3F4FAE3B0150_copy.body preserve=yes
  //## end LineList::LineList%3F4FAE3B0150_copy.body
}


LineList::~LineList()
{
  //## begin LineList::~LineList%3F4FAE3B0150_dest.body preserve=yes
  delete m_file;
  //## end LineList::~LineList%3F4FAE3B0150_dest.body
}



//## Other Operations (implementation)
LineList* LineList::get (const std::string& name)
{
  //## begin LineList::get%3F4FBD5C0295.body preserve=yes
  std::map<std::string,LineList*>::iterator il(s_lineLists.find(name));
  if (il != s_lineLists.end()) return (*il).second->clone();
  else return 0;
  //## end LineList::get%3F4FBD5C0295.body
}

void LineList::registerLineList (const std::string& name, LineList* lineList)
{
  //## begin LineList::registerLineList%3F4FBE2E00C6.body preserve=yes
  s_lineLists[name] = lineList;
  //## end LineList::registerLineList%3F4FBE2E00C6.body
}

void LineList::initialize (Real lowEnergy, Real highEnergy, Real plasmaTemp, Real minEmissivity, bool isWave)
{
  //## begin LineList::initialize%3F54BA2F0067.body preserve=yes
  m_energyRange.first = lowEnergy;
  m_energyRange.second = highEnergy;
  m_plasmaTemperature = plasmaTemp;
  m_minEmissivity = minEmissivity;
  m_isWave = isWave;
  openFile();
  readData();
  findLines();
  //## end LineList::initialize%3F54BA2F0067.body
}

void LineList::showList (std::ostream& os)
{
  //## begin LineList::showList%3F54BC7800EB.body preserve=yes
  std::ios_base::fmtflags saveState(os.flags());
  report(os);
  os.flags(saveState);
  //## end LineList::showList%3F54BC7800EB.body
}

void LineList::openFile ()
{
  //## begin LineList::openFile%3F54BCE4004A.body preserve=yes
  using namespace CCfits;
  if (m_file)
  {
     throw RedAlert("LineList: file pointer not properly set.");
  }
  try
  {
     m_file = new FITS(m_fileName);
  }
  catch (FitsException&)
  {
     throw CannotOpen(m_fileName);
  }
  //## end LineList::openFile%3F54BCE4004A.body
}

void LineList::readData ()
{
  //## begin LineList::readData%3F54BD200151.body preserve=yes
  //## end LineList::readData%3F54BD200151.body
}

void LineList::findLines ()
{
  //## begin LineList::findLines%3F54BD500374.body preserve=yes
  //## end LineList::findLines%3F54BD500374.body
}

void LineList::report (std::ostream& os) const
{
  //## begin LineList::report%3FD784450316.body preserve=yes
  //## end LineList::report%3FD784450316.body
}

void LineList::clearLineLists ()
{
  //## begin LineList::clearLineLists%429F4B0F0202.body preserve=yes
  std::map<std::string,LineList*>::iterator itLl = s_lineLists.begin();
  std::map<std::string,LineList*>::iterator itEnd = s_lineLists.end();
  while (itLl != itEnd)
  {
     delete itLl->second;
     ++itLl;
  }
  s_lineLists.clear();
  //## end LineList::clearLineLists%429F4B0F0202.body
}

// Additional Declarations
  //## begin LineList%3F4FAE3B0150.declarations preserve=yes
  //## end LineList%3F4FAE3B0150.declarations

//## begin module%3F4FA77E01A8.epilog preserve=yes
//## end module%3F4FA77E01A8.epilog
